Index: /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h
===================================================================
--- /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1082)
+++ /LMDZ4/branches/LMDZ4-dev/libf/phylmd/phys_output_write.h	(revision 1083)
@@ -8,426 +8,425 @@
 
 !!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-       IF (flag_phis(iff)<=lev_files(iff)) THEN 
+       IF (o_phis%flag(iff)<=lev_files(iff)) THEN 
          CALL histwrite_phy(nid_files(iff),
-     $                      "phis",itau_w,pphis)
-       ENDIF
-
-       IF (flag_aire(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"aire",itau_w,airephy)
-       ENDIF
-
-       IF (flag_pourc_sol(iff)<=lev_files(iff)) THEN
-      zx_tmp_fi2d(1 : klon) = pctsrf(1 : klon, is_ter)* 100.
-      CALL histwrite_phy(nid_files(iff),
-     $                   "pourc_"//clnsurf(is_ter),itau_w,
-     $                   zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_fract_sol(iff)<=lev_files(iff)) THEN
-      zx_tmp_fi2d(1 : klon) = pctsrf(1 : klon, is_ter)
-      CALL histwrite_phy(nid_files(iff),
-     $               "fract_"//clnsurf(is_ter),itau_w,
-     $               zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_contfracATM(iff)<=lev_files(iff)) THEN
+     $                      o_phis%name,itau_w,pphis)
+       ENDIF
+
+       IF (o_aire%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_aire%name,itau_w,airephy)
+       ENDIF
+
+       IF (o_contfracATM%flag(iff)<=lev_files(iff)) THEN
       DO i=1, klon
        zx_tmp_fi2d(i)=pctsrf(i,is_ter)+pctsrf(i,is_lic)
       ENDDO
       CALL histwrite_phy(nid_files(iff),
-     $                   "contfracATM",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_contfracOR(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"contfracOR",itau_w,
+     $             o_contfracATM%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_contfracOR%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_contfracOR%name,itau_w,
      $                   pctsrf(:,is_ter))
        ENDIF
 
-       IF (flag_aireTER(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
-     $                  "aireTER",itau_w,paire_ter)
+       IF (o_aireTER%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     $                  o_aireTER%name,itau_w,paire_ter)
        ENDIF
 
 !!! Champs 2D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
-       IF (flag_flat(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"flat",itau_w,zxfluxlat)
-       ENDIF
-
-       IF (flag_slp(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"slp",itau_w,slp)
-       ENDIF
-
-       IF (flag_tsol(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tsol",itau_w,zxtsol)
-       ENDIF
-
-       IF (flag_t2m(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"t2m",itau_w,zt2m)
-       ENDIF
-
-       IF (flag_t2m_min(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"t2m_min",itau_w,zt2m)
-       ENDIF
-
-       IF (flag_t2m_max(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"t2m_max",itau_w,zt2m)
-       ENDIF
-
-       IF (flag_wind10m(iff)<=lev_files(iff)) THEN
+       IF (o_flat%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_flat%name,itau_w,zxfluxlat)
+       ENDIF
+
+       IF (o_slp%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_slp%name,itau_w,slp)
+       ENDIF
+
+       IF (o_tsol%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tsol%name,itau_w,zxtsol)
+       ENDIF
+
+       IF (o_t2m%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_t2m%name,itau_w,zt2m)
+       ENDIF
+
+       IF (o_t2m_min%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_t2m_min%name,itau_w,zt2m)
+       ENDIF
+
+       IF (o_t2m_max%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_t2m_max%name,itau_w,zt2m)
+       ENDIF
+
+       IF (o_wind10m%flag(iff)<=lev_files(iff)) THEN
       DO i=1, klon
        zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"wind10m",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_wind10max(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                  o_wind10m%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_wind10max%flag(iff)<=lev_files(iff)) THEN
       DO i=1, klon
        zx_tmp_fi2d(i)=SQRT(zu10m(i)*zu10m(i)+zv10m(i)*zv10m(i))
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"wind10max", 
+      CALL histwrite_phy(nid_files(iff),o_wind10max%name, 
      $                   itau_w,zx_tmp_fi2d)
        ENDIF
 
-       IF (flag_sicf(iff)<=lev_files(iff)) THEN
+       IF (o_sicf%flag(iff)<=lev_files(iff)) THEN
       DO i = 1, klon
          zx_tmp_fi2d(i) = pctsrf(i,is_sic)
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"sicf",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_q2m(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"q2m",itau_w,zq2m)
-       ENDIF
-
-       IF (flag_u10m(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"u10m",itau_w,zu10m)
-       ENDIF
-
-       IF (flag_v10m(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"v10m",itau_w,zv10m)
-       ENDIF
-
-       IF (flag_psol(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     $                   o_sicf%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_q2m%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_q2m%name,itau_w,zq2m)
+       ENDIF
+
+       IF (o_u10m%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_u10m%name,itau_w,zu10m)
+       ENDIF
+
+       IF (o_v10m%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_v10m%name,itau_w,zv10m)
+       ENDIF
+
+       IF (o_psol%flag(iff)<=lev_files(iff)) THEN
       DO i = 1, klon
          zx_tmp_fi2d(i) = paprs(i,1)
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"psol",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_qsurf(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"qsurf",itau_w,zxqsurf)
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_psol%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_qsurf%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_qsurf%name,itau_w,zxqsurf)
        ENDIF
 
        if (.not. ok_veget) then
-         IF (flag_qsol(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),"qsol",itau_w,qsol)
+         IF (o_qsol%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),o_qsol%name,itau_w,qsol)
          ENDIF
        endif
 
-      IF (flag_precip(iff)<=lev_files(iff)) THEN
+      IF (o_precip%flag(iff)<=lev_files(iff)) THEN
        DO i = 1, klon
          zx_tmp_fi2d(i) = rain_fall(i) + snow_fall(i)
        ENDDO
-      CALL histwrite_phy(nid_files(iff),"precip",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-       IF (flag_ndayrain(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"ndayrain",itau_w,nday_rain)
-       ENDIF
-
-      IF (flag_plul(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_precip%name,
+     s                   itau_w,zx_tmp_fi2d)
+      ENDIF
+
+       IF (o_ndayrain%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_ndayrain%name,
+     s                   itau_w,nday_rain)
+       ENDIF
+
+      IF (o_plul%flag(iff)<=lev_files(iff)) THEN
        DO i = 1, klon
          zx_tmp_fi2d(i) = rain_lsc(i) + snow_lsc(i)
        ENDDO
-      CALL histwrite_phy(nid_files(iff),"plul",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-      IF (flag_pluc(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_plul%name,itau_w,zx_tmp_fi2d)
+      ENDIF
+
+      IF (o_pluc%flag(iff)<=lev_files(iff)) THEN
       DO i = 1, klon
          zx_tmp_fi2d(i) = rain_con(i) + snow_con(i)
       ENDDO
-      CALL histwrite_phy(nid_files(iff),"pluc",itau_w,zx_tmp_fi2d)
-      ENDIF
-
-       IF (flag_snow(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"snow",itau_w,snow_fall)
-       ENDIF
-
-       IF (flag_evap(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"evap",itau_w,evap)
-       ENDIF
-
-       IF (flag_tops(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tops",itau_w,topsw)
-       ENDIF
-
-       IF (flag_tops0(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"tops0",itau_w,topsw0)
-       ENDIF
-
-       IF (flag_topl(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"topl",itau_w,toplw)
-       ENDIF
-
-       IF (flag_topl0(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"topl0",itau_w,toplw0)
-       ENDIF
-
-       IF (flag_SWupTOA(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_pluc%name,itau_w,zx_tmp_fi2d)
+      ENDIF
+
+       IF (o_snow%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_snow%name,itau_w,snow_fall)
+       ENDIF
+
+       IF (o_evap%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_evap%name,itau_w,evap)
+       ENDIF
+
+       IF (o_tops%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tops%name,itau_w,topsw)
+       ENDIF
+
+       IF (o_tops0%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_tops0%name,itau_w,topsw0)
+       ENDIF
+
+       IF (o_topl%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_topl%name,itau_w,toplw)
+       ENDIF
+
+       IF (o_topl0%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_topl0%name,itau_w,toplw0)
+       ENDIF
+
+       IF (o_SWupTOA%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swup ( 1 : klon, klevp1 )
-      CALL histwrite_phy(nid_files(iff), "SWupTOA",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWupTOAclr(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_SWupTOA%name,
+     s                     itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWupTOAclr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swup0 ( 1 : klon, klevp1 )
       CALL histwrite_phy(nid_files(iff), 
-     $                  "SWupTOAclr",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWdnTOA(iff)<=lev_files(iff)) THEN
+     $                  o_SWupTOAclr%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWdnTOA%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swdn ( 1 : klon, klevp1 )
-      CALL histwrite_phy(nid_files(iff), "SWdnTOA",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWdnTOAclr(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                  o_SWdnTOA%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWdnTOAclr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swdn0 ( 1 : klon, klevp1 )
       CALL histwrite_phy(nid_files(iff), 
-     $                  "SWdnTOAclr",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWup200(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"SWup200",itau_w,SWup200)
-       ENDIF
-
-       IF (flag_SWup200clr(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"SWup200clr",itau_w,SWup200clr)
-       ENDIF
-
-       IF (flag_SWdn200(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"SWdn200",itau_w,SWdn200)
-       ENDIF
-
-       IF (flag_SWdn200clr(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"SWdn200clr",itau_w,SWdn200clr)
-       ENDIF
-
-       IF (flag_LWup200(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"LWup200",itau_w,LWup200)
-       ENDIF
-
-       IF (flag_LWup200clr(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"LWup200clr",itau_w,LWup200clr)
-       ENDIF
-
-       IF (flag_LWdn200(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"LWdn200",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_LWdn200clr(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"LWdn200clr",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_sols(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"sols",itau_w,solsw)
-       ENDIF
-
-       IF (flag_sols0(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"sols0",itau_w,solsw0)
-       ENDIF
-
-       IF (flag_soll(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"soll",itau_w,sollw)
-       ENDIF
-
-       IF (flag_radsol(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"radsol",itau_w,radsol)
-       ENDIF
-
-       IF (flag_soll0(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"soll0",itau_w,sollw0)
-       ENDIF
-
-       IF (flag_SWupSFC(iff)<=lev_files(iff)) THEN
+     $                  o_SWdnTOAclr%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWup200%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_SWup200%name,itau_w,SWup200)
+       ENDIF
+
+       IF (o_SWup200clr%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_SWup200clr%name,itau_w,SWup200clr)
+       ENDIF
+
+       IF (o_SWdn200%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_SWdn200%name,itau_w,SWdn200)
+       ENDIF
+
+       IF (o_SWdn200clr%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                o_SWdn200clr%name,itau_w,SWdn200clr)
+       ENDIF
+
+       IF (o_LWup200%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_LWup200%name,itau_w,LWup200)
+       ENDIF
+
+       IF (o_LWup200clr%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_LWup200clr%name,itau_w,LWup200clr)
+       ENDIF
+
+       IF (o_LWdn200%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                   o_LWdn200%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_LWdn200clr%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s                  o_LWdn200clr%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_sols%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_sols%name,itau_w,solsw)
+       ENDIF
+
+       IF (o_sols0%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_sols0%name,itau_w,solsw0)
+       ENDIF
+
+       IF (o_soll%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_soll%name,itau_w,sollw)
+       ENDIF
+
+       IF (o_radsol%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_radsol%name,itau_w,radsol)
+       ENDIF
+
+       IF (o_soll0%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_soll0%name,itau_w,sollw0)
+       ENDIF
+
+       IF (o_SWupSFC%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swup ( 1 : klon, 1 )
-      CALL histwrite_phy(nid_files(iff), "SWupSFC",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWupSFCclr(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     s               o_SWupSFC%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWupSFCclr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swup0 ( 1 : klon, 1 )
       CALL histwrite_phy(nid_files(iff), 
-     $                   "SWupSFCclr",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWdnSFC(iff)<=lev_files(iff)) THEN
+     $                   o_SWupSFCclr%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWdnSFC%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swdn ( 1 : klon, 1 )
       CALL histwrite_phy(nid_files(iff), 
-     $                   "SWdnSFC",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_SWdnSFCclr(iff)<=lev_files(iff)) THEN
+     $                   o_SWdnSFC%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_SWdnSFCclr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = swdn0 ( 1 : klon, 1 )
       CALL histwrite_phy(nid_files(iff), 
-     $                  "SWdnSFCclr",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_LWupSFC(iff)<=lev_files(iff)) THEN
+     $                  o_SWdnSFCclr%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_LWupSFC%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1:klon)=sollwdown(1:klon)-sollw(1:klon)
       CALL histwrite_phy(nid_files(iff),
-     $                    "LWupSFC",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_LWdnSFC(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
-     $                   "LWdnSFC",itau_w,sollwdown)
+     $                    o_LWupSFC%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_LWdnSFC%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     $                   o_LWdnSFC%name,itau_w,sollwdown)
        ENDIF
 
        sollwdownclr(1:klon) = -1.*lwdn0(1:klon,1)
-       IF (flag_LWupSFCclr(iff)<=lev_files(iff)) THEN
+       IF (o_LWupSFCclr%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1:klon)=sollwdownclr(1:klon)-sollw0(1:klon)
       CALL histwrite_phy(nid_files(iff),
-     $                   "LWupSFCclr",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_LWdnSFCclr(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),
-     $                   "LWdnSFCclr",itau_w,sollwdownclr)
-       ENDIF
-
-       IF (flag_bils(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"bils",itau_w,bils)
-       ENDIF
-
-       IF (flag_sens(iff)<=lev_files(iff)) THEN
+     $                   o_LWupSFCclr%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_LWdnSFCclr%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),
+     $                   o_LWdnSFCclr%name,itau_w,sollwdownclr)
+       ENDIF
+
+       IF (o_bils%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_bils%name,itau_w,bils)
+       ENDIF
+
+       IF (o_sens%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1:klon)=-1*sens(1:klon)
-      CALL histwrite_phy(nid_files(iff),"sens",itau_w,zx_tmp_fi2d)
-       ENDIF
-
-       IF (flag_fder(iff)<=lev_files(iff)) THEN
-      CALL histwrite_phy(nid_files(iff),"fder",itau_w,fder)
-       ENDIF
-
-       IF (flag_ffonte(iff)<=lev_files(iff)) THEN
-       CALL histwrite_phy(nid_files(iff),"ffonte",itau_w,zxffonte)
-       ENDIF
-
-       IF (flag_fqcalving(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_sens%name,itau_w,zx_tmp_fi2d)
+       ENDIF
+
+       IF (o_fder%flag(iff)<=lev_files(iff)) THEN
+      CALL histwrite_phy(nid_files(iff),o_fder%name,itau_w,fder)
+       ENDIF
+
+       IF (o_ffonte%flag(iff)<=lev_files(iff)) THEN
+       CALL histwrite_phy(nid_files(iff),o_ffonte%name,itau_w,zxffonte)
+       ENDIF
+
+       IF (o_fqcalving%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),
-     $                    "fqcalving",itau_w,zxfqcalving)
-       ENDIF
-
-       IF (flag_fqfonte(iff)<=lev_files(iff)) THEN
+     $                    o_fqcalving%name,itau_w,zxfqcalving)
+       ENDIF
+
+       IF (o_fqfonte%flag(iff)<=lev_files(iff)) THEN
        CALL histwrite_phy(nid_files(iff),
-     $                    "fqfonte",itau_w,zxfqfonte)
+     $                   o_fqfonte%name,itau_w,zxfqfonte)
        ENDIF
 
          DO nsrf = 1, nbsrf
-           IF(nsrf.GE.2) THEN
-            IF (flag_pourc_sol(iff)<=lev_files(iff)) THEN
+!           IF(nsrf.GE.2) THEN
+            IF (o_pourc_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
             zx_tmp_fi2d(1 : klon) = pctsrf( 1 : klon, nsrf)*100.
             CALL histwrite_phy(nid_files(iff),
-     $                     "pourc_"//clnsurf(nsrf),itau_w,
+     $                     o_pourc_srf(nsrf)%name,itau_w,
      $                     zx_tmp_fi2d)
             ENDIF
 
-          IF (flag_fract_sol(iff)<=lev_files(iff)) THEN
+          IF (o_fract_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
           zx_tmp_fi2d(1 : klon) = pctsrf( 1 : klon, nsrf)
           CALL histwrite_phy(nid_files(iff),
-     $                    "fract_"//clnsurf(nsrf),itau_w,
+     $                  o_fract_srf(nsrf)%name,itau_w,
+     $                  zx_tmp_fi2d)
+          ENDIF
+!         ENDIF !nsrf.GT.2
+
+        IF (o_taux_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
+        zx_tmp_fi2d(1 : klon) = fluxu( 1 : klon, 1, nsrf)
+        CALL histwrite_phy(nid_files(iff),
+     $                     o_taux_srf(nsrf)%name,itau_w,
+     $                     zx_tmp_fi2d)
+        ENDIF
+
+        IF (o_tauy_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN           
+        zx_tmp_fi2d(1 : klon) = fluxv( 1 : klon, 1, nsrf)
+        CALL histwrite_phy(nid_files(iff),
+     $                    o_tauy_srf(nsrf)%name,itau_w,
+     $                    zx_tmp_fi2d)
+        ENDIF
+
+        IF (o_tsol_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
+        zx_tmp_fi2d(1 : klon) = ftsol( 1 : klon, nsrf)
+        CALL histwrite_phy(nid_files(iff),
+     $                   o_tsol_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
-          ENDIF
-         ENDIF !nsrf.GT.2
-
-        IF (flag_taux_sol(iff)<=lev_files(iff)) THEN
-        zx_tmp_fi2d(1 : klon) = fluxu( 1 : klon, 1, nsrf)
-        CALL histwrite_phy(nid_files(iff),
-     $                     "taux_"//clnsurf(nsrf),itau_w,
-     $      zx_tmp_fi2d)
-        ENDIF
-
-        IF (flag_tauy_sol(iff)<=lev_files(iff)) THEN           
-        zx_tmp_fi2d(1 : klon) = fluxv( 1 : klon, 1, nsrf)
-        CALL histwrite_phy(nid_files(iff),
-     $                    "tauy_"//clnsurf(nsrf),itau_w,
-     $      zx_tmp_fi2d)
-        ENDIF
-
-        IF (flag_tsol_sol(iff)<=lev_files(iff)) THEN
-        zx_tmp_fi2d(1 : klon) = ftsol( 1 : klon, nsrf)
-        CALL histwrite_phy(nid_files(iff),
-     $                   "tsol_"//clnsurf(nsrf),itau_w,
-     $      zx_tmp_fi2d)
-        ENDIF
-
-      IF (flag_u10m_sol(iff)<=lev_files(iff)) THEN
+        ENDIF
+
+      IF (o_u10m_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = u10m(1 : klon, nsrf)
-      CALL histwrite_phy(nid_files(iff),"u10m_"//clnsurf(nsrf),
+      CALL histwrite_phy(nid_files(iff),o_u10m_srf(nsrf)%name,
      $                 itau_w,zx_tmp_fi2d)
       ENDIF
 
-      IF (flag_v10m_sol(iff)<=lev_files(iff)) THEN
+      IF (o_v10m_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = v10m(1 : klon, nsrf)
-      CALL histwrite_phy(nid_files(iff),"v10m_"//clnsurf(nsrf),
+      CALL histwrite_phy(nid_files(iff),o_v10m_srf(nsrf)%name,
      $              itau_w,zx_tmp_fi2d)
       ENDIF
  
-      IF (flag_t2m_sol(iff)<=lev_files(iff)) THEN
+      IF (o_t2m_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
       zx_tmp_fi2d(1 : klon) = t2m(1 : klon, nsrf)
-      CALL histwrite_phy(nid_files(iff),"t2m_"//clnsurf(nsrf),
+      CALL histwrite_phy(nid_files(iff),o_t2m_srf(nsrf)%name,
      $           itau_w,zx_tmp_fi2d)
       ENDIF
 
-       IF (flag_sens_sol(iff)<=lev_files(iff)) THEN
+       IF (o_sens_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
        zx_tmp_fi2d(1 : klon) = fluxt( 1 : klon, 1, nsrf)
        CALL histwrite_phy(nid_files(iff),
-     $                     "sens_"//clnsurf(nsrf),itau_w,
+     $                    o_sens_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
        ENDIF
 
-        IF (flag_lat_sol(iff)<=lev_files(iff)) THEN
+        IF (o_lat_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = fluxlat( 1 : klon, nsrf)
         CALL histwrite_phy(nid_files(iff),
-     $                 "lat_"//clnsurf(nsrf),itau_w,
+     $                 o_lat_srf(nsrf)%name,itau_w,
      $                                   zx_tmp_fi2d)
           ENDIF
 
-        IF (flag_flw_sol(iff)<=lev_files(iff)) THEN
+        IF (o_flw_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = fsollw( 1 : klon, nsrf)
         CALL histwrite_phy(nid_files(iff),
-     $                     "flw_"//clnsurf(nsrf),itau_w,
+     $                     o_flw_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
         ENDIF
 
-        IF (flag_fsw_sol(iff)<=lev_files(iff)) THEN
+        IF (o_fsw_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = fsolsw( 1 : klon, nsrf)
         CALL histwrite_phy(nid_files(iff),
-     $                     "fsw_"//clnsurf(nsrf),itau_w,
+     $                   o_fsw_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
         ENDIF
 
-        IF (flag_wbils_sol(iff)<=lev_files(iff)) THEN
+        IF (o_wbils_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = wfbils( 1 : klon, nsrf)
         CALL histwrite_phy(nid_files(iff),
-     $                     "wbils_"//clnsurf(nsrf),itau_w,
+     $                   o_wbils_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
         ENDIF
 
-        IF (flag_wbilo_sol(iff)<=lev_files(iff)) THEN
+        IF (o_wbilo_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
         zx_tmp_fi2d(1 : klon) = wfbilo( 1 : klon, nsrf)
         CALL histwrite_phy(nid_files(iff),
-     $                    "wbilo_"//clnsurf(nsrf),itau_w,
+     $                    o_wbilo_srf(nsrf)%name,itau_w,
      $      zx_tmp_fi2d)
         ENDIF
 
        if (iflag_pbl>1 .and. lev_histday.gt.10 ) then
-        IF (flag_tke_sol(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),
-     $                    "tke_"//clnsurf(nsrf),itau_w,
-     $      pbl_tke(:,1:klev,nsrf))
-       ENDIF
-
-        IF (flag_tke_max_sol(iff)<=lev_files(iff)) THEN
-        CALL histwrite_phy(nid_files(iff),
-     $                    "tke_max_"//clnsurf(nsrf),itau_w,
+        IF (o_tke_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),
+     $                   o_tke_srf(nsrf)%name,itau_w,
+     $                    pbl_tke(:,1:klev,nsrf))
+       ENDIF
+
+        IF (o_tke_max_srf(nsrf)%flag(iff)<=lev_files(iff)) THEN
+        CALL histwrite_phy(nid_files(iff),
+     $                    o_tke_max_srf(nsrf)%name,itau_w,
      $      pbl_tke(:,1:klev,nsrf))
         ENDIF
